/* INET socket version */

/* Buket ULU */
/* 105330-5 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <unistd.h>


#define PORT 2737

void main(){
	int s,c;
	struct sockaddr_in * name;
	int addrlen;
	char buffer[250];
	int pid,o;	
	char host[31];
	struct hostent * hptr;


/* Get hostname */
if (gethostname(host,30)==-1){
	printf("Error while getting hostname.\n");
	exit(1);
}
/* Get address information */
if((hptr=gethostbyname(host))==NULL){
	printf("Error while getting the address information of the host.\n");
	exit(1);
}

name=(struct sockaddr_in *)malloc(sizeof(&name));
name->sin_family=hptr->h_addrtype;
name->sin_port=htons(PORT);
addrlen=sizeof(&name);
 
 /* Create socket */
if ((s=socket(AF_INET,SOCK_STREAM,0))==-1) {
	printf("Cannot create a socket.\n");
	exit(1);
}

/* Bind it */
if (bind(s,(struct sockaddr *)name,sizeof(&name))==-1){
	printf("Cannot bind socket.\n");
	exit(1);
}
/* Listen */
if (listen(s,3)==-1){
	printf("Error in listen.\n");
	exit(1);
}
/* Accept */

while(1){
	if ((c=accept(s,(struct sockaddr *)name,&addrlen))==-1){
		printf("Error in accept\n");
		exit(1);
	}
	/* FORK */
	if ((pid=fork())==-1){
		printf("Error in fork.\n");
		close(s); close(c);
		exit(1);
	}
	if (pid==0){
		int sum,num1,num2;
		close(s);
		if (recv(c,buffer,250,0)==-1){
			printf("Error while receiving data.\n");
			exit(1);
		}
		sscanf(buffer,"%d %d",&num1,&num2);
		printf("num1==>%d, num2==>%d\n",num1,num2);
		sum=num1+num2;
		sprintf(buffer,"%d",sum);
		if (send(c,buffer,250,0)==-1){
			printf("Error in sending buffer.\n");
			exit(1);
		}
		exit(0);
	}
	else{
		close(c);
		wait(NULL);
	}

}


	
}
