#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#define PORT 3490    /* the port client will connect to */

int main(int argc, char *argv[])
{
  int sockfd;
  int num1, num2, result; 
  struct hostent *he;
  struct sockaddr_in their_addr; /* connector's address information */
  if (argc != 4) {
     fprintf(stderr, "usage: client <hostname> <num1> <num2>\n");
     exit(1);
  }
  num1 = htonl(atoi(argv[2]));
  num2 = htonl(atoi(argv[3]));

  if ((he=gethostbyname(argv[1])) == NULL) { /* get the host info */
      perror("gethostbyname");
      exit(1);
  } 
  if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
      perror("socket");
      exit(1);
  }
  their_addr.sin_family = AF_INET;  /* host byte order */
  their_addr.sin_port   = htons(PORT);  /* sort, network byte order */
  their_addr.sin_addr   = *((struct in_addr *)he->h_addr);
  bzero(&(their_addr.sin_zero), 8);     /* zero the rest of the struct */


  if (connect(sockfd, (struct sockaddr *)&their_addr, sizeof(struct sockaddr)) == -1) {
    perror("connect");
    exit(1);
  }

  if (send(sockfd,(char *)&num1, sizeof(int), 0) == -1) {
    perror("send");                                 
    exit(1);
  }

  if (send(sockfd, (char *)&num2, sizeof(int), 0) == -1) {
    perror("send");                                 
    exit(1);
  }

  if ((recv(sockfd, (char *)&result, sizeof(int), 0)) == -1) {
    perror("recv");
    exit(1);
  }
  result = ntohl(result);
  printf("\nclient : Result: %d\n", result);
 
 close(sockfd);

 return 0;
}

