#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/wait.h>

#define MYPORT 3490   /* the port user will be connecting to */
#define BACKLOG 10    /* how many pending connections queue will hold */

main()
{
  int sockfd, new_fd; /*listen on sock_fd, new connection on new_fd */
  struct sockaddr_in my_addr;  /* my address information */
  struct sockaddr_in their_addr;  /* connector's address information */
  int num1, num2;
  int result;
  int sin_size;

  if ((sockfd = socket(AF_INET, SOCK_STREAM,0)) == -1) {
      perror("socket");
      exit(1);
  }

  my_addr.sin_family = AF_INET;	 /* host byte order */
  my_addr.sin_port   = htons(MYPORT);   /* short, network byte order */
  my_addr.sin_addr.s_addr = INADDR_ANY; /* auto-fill with my IP      */
  bzero(&(my_addr.sin_zero), 8);        /* zero the rest of tne struct */

  if (bind(sockfd, (struct sockaddr *)&my_addr, sizeof(struct sockaddr)) == -1) {
     perror("bind");
     fprintf(stderr, "Try another port...\n");
     exit(1);
  }

  if (listen(sockfd,BACKLOG) == -1) {
     perror("listen");
     exit(1);
  }

 while (1) {  /* main accept loop */
     sin_size = sizeof(struct sockaddr_in);
     if ((new_fd = accept(sockfd, (struct sockaddr *)&their_addr, &sin_size)) == -1) {
        perror("accept");
        continue;
     }

     if (!fork()) { /* this is the child process */
        if (recv(new_fd, (char *)&num1, sizeof(int) ,0) == -1) {
           perror("recv");
           exit(1);
        }
        if (recv(new_fd, (char *)&num2, sizeof(int) ,0) == -1) {
           perror("recv");
           exit(1);
        }
        num1 = ntohl(num1);
        num2 = ntohl(num2);
        result = num1+num2;
        result = htonl(result);
        if (send(new_fd, (char *)&result, sizeof(int), 0) == -1)
           perror("send");
        close(new_fd);
        exit(0);
     }
    close(new_fd);   /* parent doesn't need this */
    
//    while (waitpid(-1,NULL,WNOHANG) > 0); /* clean up child process */
 }
}

