/*****************  Fikret Can, 05/05/200            **********************/
/***************** UNIX Domain Socket Implementation **********************/
/***************** FILE        : client.c            **********************/
/***************** COMPILE     : gcc client.c -lnsl -lsocket -o client ****/
/***************** USE         : ./client hostname num1 num2           ****/ 
/***************** PS          : first run server (./server&)          ****/
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <netdb.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/un.h>

#define DEFAULT_PROTOCOL 0
#define PIPE "/tmp/pipe"

int main(int argc, char *argv[])
{
  int sockfd;
  int num1, num2, result; 
  struct sockaddr_un their_addr;

  if (argc != 3) {
     fprintf(stderr, "usage: client <num1> <num2>\n");
     exit(1);
  }

  num1 = atoi(argv[1]);
  num2 = atoi(argv[2]);

  if ((sockfd = socket(AF_UNIX, SOCK_STREAM, DEFAULT_PROTOCOL)) == -1) {
      perror("socket");
      exit(1);
  }

  their_addr.sun_family = AF_UNIX;  /* host byte order */
  strcpy(their_addr.sun_path, PIPE);  /* sort, network byte order */

  if (connect(sockfd, (struct sockaddr *)&their_addr, sizeof(struct sockaddr)) == -1) {
     perror("connect");
     exit(1);
  }

  num1 = htonl(num1);
  if (send(sockfd, (char *)&num1, sizeof(int), 0) == -1) {
     perror("send");                                 
     exit(1);
  }

  num2 = htonl(num2);
  if (send(sockfd, (char *)&num2, sizeof(int), 0) == -1) {
     perror("send");                                 
     exit(1);
  } 

  if ((recv(sockfd, (char *)&result, sizeof(int), 0)) == -1) {
     perror("recv");
     exit(1);
  }
  result = ntohl(result);
  printf("client: Received: %d\n", result);
 
  close(sockfd);

  return 0;
}

