#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <sys/un.h>

#define BACKLOG 10
#define DEFAULT_PROTOCOL 0
#define PIPE "/tmp/pipe"

main()
{
  int sockfd, new_fd; /*listen on sock_fd, new connection on new_fd */
  struct sockaddr_un my_addr;  /* my address information */
  struct sockaddr_un their_addr;  /* connector's address information */
  int num1, num2;
  int result;
  int sun_size;

  if ((sockfd = socket(AF_UNIX, SOCK_STREAM,DEFAULT_PROTOCOL)) == -1) {
      perror("socket");
      exit(1);
  }

  my_addr.sun_family = AF_UNIX;	 /* host byte order */
  strcpy(my_addr.sun_path, PIPE);   /* short, network byte order */

  unlink(PIPE);
  if (bind(sockfd, (struct sockaddr *)&my_addr, sizeof(struct sockaddr)) == -1) {
     perror("bind");
     exit(1);
  }

  if (listen(sockfd,BACKLOG) == -1) {
     perror("listen");
     exit(1);
  }
 
 while (1) {  /* main accept loop */
     sun_size = sizeof(struct sockaddr_un);
     if ((new_fd = accept(sockfd, (struct sockaddr *)&their_addr, &sun_size)) == -1) {
        perror("accept");
        continue;
     }

     if (!fork()) { /* this is the child process */
        if (recv(new_fd, (char *)&num1, sizeof(int) ,0) == -1) {
           perror("recv");
           exit(1);
        }
        if (recv(new_fd, (char *)&num2, sizeof(int) ,0) == -1) {
           perror("recv");
           exit(1);
        }
        num1 = ntohl(num1);
        num2 = ntohl(num2);
        result = num1+num2;
        result = htonl(result);
        if (send(new_fd, (char *)&result, sizeof(int), 0) == -1)
           perror("send");
        close(new_fd);
        exit(0);
     }
    close(new_fd);   /* parent doesn't need this */
    
    while (waitpid(-1,NULL,WNOHANG) > 0); /* clean up child process */
 }
}

