/*
** server.c -- a stream socket server demo
*/

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/wait.h>

#define MYPORT 3490    /* the port users will be connecting to */

#define BACKLOG 10     /* how many pending connections queue will hold */

#define MAXDATASIZE 100
#define VALID       1
#define INVALID     0

char valid_op(char *op) {

       if (  ( op[0]!='+' && op[0]!='x' &&
               op[0]!='-' && op[0]!='/' )|| strlen(op)!=1) return INVALID;
       return VALID;
}

char valid_arg(char *arg) {
     int i; 

     for(i=0;arg[i]&& i<8;i++) if (arg[i]<'0'|| arg[i]>'9') return INVALID;
     return VALID;
}
     
main()
{
    int sockfd, new_fd;  /* listen on sock_fd, new connection on new_fd */
    struct sockaddr_in my_addr;    /* my address information */
    struct sockaddr_in their_addr; /* connector's address information */
    int sin_size;

    int numbytes,i,k;
    char operator,err;
    long int arg1,arg2,result;
    char temp[MAXDATASIZE],buf[MAXDATASIZE];
    char resultstr[MAXDATASIZE];
    

    if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
        perror("socket");
        exit(1);
    }

    my_addr.sin_family = AF_INET;         /* host byte order */
    my_addr.sin_port = htons(MYPORT);     /* short, network byte order */
    my_addr.sin_addr.s_addr = INADDR_ANY; /* automatically fill with my IP */
    bzero(&(my_addr.sin_zero), 8);        /* zero the rest of the struct */

    if (bind(sockfd, (struct sockaddr *)&my_addr, sizeof(struct sockaddr)) == -1) {
        perror("bind");
        exit(1);
    }

    if (listen(sockfd, BACKLOG) == -1) {
        perror("listen");
        exit(1);
    }

    while(1) {  /* main accept() loop */
        sin_size = sizeof(struct sockaddr_in);
        if ((new_fd = accept(sockfd, (struct sockaddr *)&their_addr, &sin_size)) == -1) {
            perror("accept");
            continue;
        }

        printf("\nserver: got connection from %s\n",inet_ntoa(their_addr.sin_addr));

        if (!fork()) { /* this is the child process */
            err=0;
            resultstr[0]=0;

            if ( (numbytes=recv(new_fd,buf,MAXDATASIZE,0) ) == -1) {
                perror("recv");  
                err++; 
                sprintf(resultstr,"couldn't get the data\n");
            }
            else {
                    buf[numbytes]='\0';
                    printf("question: %s\n",buf);

                    if (buf[0]=='q') {
                       close(new_fd);
                       kill(getppid(),SIGTERM);
                       exit(0);
                    }



                    i=0;
                    while(buf[i]!=' ') temp[i]=buf[i++];
                    temp[i]='\0';
                    if (valid_arg(temp)) arg1=atol(temp);
                    else {
                           sprintf(resultstr,"%sinvalid argument \"%s\"\n",resultstr,temp);
                           err++;
                    }
                    i++;

                    k=0;
                    while(buf[i]!=' ') temp[k++]=buf[i++];
                    temp[k]='\0';
                    if (valid_op(temp)) operator=temp[0];
                    else {
                           sprintf(resultstr,"%sinvalid operator \"%s\"\n",resultstr,temp);
                           err++;
                    }
                    i++;
                    
                    k=0;
                    while(buf[i]!=0) temp[k++]=buf[i++];
                    temp[k]='\0';
                    if (valid_arg(temp)) arg2=atol(temp);
                    else {
                           sprintf(resultstr,"%sinvalid argument \"%s\"\n",resultstr,temp);
                           err++;
                    }
                    i++;



          
            if (!err) {
                switch(operator) {
                       case '+' : result=arg1+arg2; break;
                       case 'x' : result=arg1*arg2; break;
                       case '-' : result=arg1-arg2; break;
                       case '/' : result=arg1/arg2; break;
                }
           
                sprintf(resultstr,"%ld",result);
            }
            else {
                   sprintf(temp,"\n%s",resultstr);
                   strcpy(resultstr,temp);
            }

        }
            printf("result: %s\n",resultstr);

            if (send(new_fd, resultstr, strlen(resultstr), 0) == -1)
                perror("send");
            close(new_fd);
            exit(0);
        }
        close(new_fd);  /* parent doesn't need this */

        while(waitpid(-1,NULL,WNOHANG) > 0); /* clean up all child processes */
    }
    close(sockfd);
}


