/******** Nurettin CETINKAYA ********/
/************************************/
/********* server.c *****************/
/************************************/
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include "telnet.h"   
#include <unistd.h>
#include <arpa/inet.h>

#define MYPORT 3490    /* the port users will be connecting to */

#define BACKLOG 10     /* how many pending connections queue will hold */
#define MAXDATASIZE 6

    	char number1[MAXDATASIZE]; /* numbers received from the client */
    	char number2[MAXDATASIZE];

int main()
{
    	char dummy;
    	int numbytes,sum = 0;
    	int num1,num2,remain,j=0,size;
    	int sockfd, new_fd;  /* listen on sock_fd, new connection on new_fd */
    	struct sockaddr_in my_addr;    /* my address information */
    	struct sockaddr_in their_addr; /* connector's address information */
    	int sin_size;
    	const   char    echo_off_str    [] = { IAC, WILL, TELOPT_ECHO, '\0' };
    	const   char    echo_on_str     [] = { IAC, WONT, TELOPT_ECHO, '\0' };
    	int i=0;

    	if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) 
	{
        	perror("socket");
        	exit(1);
    	}

    	my_addr.sin_family = AF_INET;         /* host byte order */
    	my_addr.sin_port = htons(MYPORT);     /* short, network byte order */
    	my_addr.sin_addr.s_addr = INADDR_ANY; /* automatically fill with my IP */
    	bzero(&(my_addr.sin_zero), 8);        /* zero the rest of the struct */

   	if (bind(sockfd, (struct sockaddr *)&my_addr, sizeof(struct sockaddr)) == -1) 
	{
        	perror("bind");
        	exit(1);
    	}

    	if (listen(sockfd, BACKLOG) == -1) 
	{
        	perror("listen");
        	exit(1);
    	}

    	while(1) 
	{  /* main accept() loop */
        	sin_size = sizeof(struct sockaddr_in);
        	if ((new_fd = accept(sockfd, (struct sockaddr *)&their_addr, &sin_size)) == -1) 
		{
            		perror("accept");
            		continue;
        	}
        	printf("server: got connection from %s\n",inet_ntoa(their_addr.sin_addr));
        	if (!fork())
		{ /* this is the child process */
            		close(sockfd);

/************** receive first number from the client***************/
            		if((numbytes=recv(new_fd, number1, MAXDATASIZE, 0)) == -1)
			{
                		perror("receive:");
                		close(new_fd);
                		exit(1);
			}

/************** receive second number from the client***************/
            		if((numbytes=recv(new_fd, number2, MAXDATASIZE, 0)) == -1) 
			{
                		perror("receive:");
                		close(new_fd);
                		exit(1);
             		}

			/*    add the numbers     */
			num1 = atoi(number1);
			num2 = atoi(number2);
			sum = num1 + num2;
			while(1)
			{
				if(sum <= 0) break;
				remain = sum % 10;
				sum /= 10;
				number1[j++] = (char) 48 + remain;
			}

			number1[j] = '\0';
	
			size = strlen(number1);
			size -= 1;
			for(j=0; j  < size ;j++)
			{
				dummy = number1[j];
				number1[j] = number1[size];
				number1[size--] = dummy;
			}
			/* end of the addition part*/		

			/* send the sum to the client */
         		if (send(new_fd,number1,10, 0) == -1)
               			perror("send3");

			close(new_fd); /* close the child process */
                	exit(0);
		
        	}
        	close(new_fd);  /* parent doesn't need this */
        	while(waitpid(-1,NULL,WNOHANG) > 0); /* clean up all child processes */
    	}
}
