#include<stdio.h>
#include<stdlib.h>
#include<errno.h>
#include<string.h>
#include<sys/types.h>
#include<netinet/in.h>
#include<sys/socket.h>
#include<sys/wait.h>
#include<netdb.h>


#define PORT 1978

#define BUFLEN 50

#define ADD '+'
#define SUB '-'
#define MUL '*'
#define DIV '/'

int str_int(char *str)
{
 int i,j,res,mul;
 
 i=0;
 mul=1;
 if(str[0]=='-')
 {
  i=1;
  mul=-1;
 }
 else if(str[0]=='+')
       i=1;
 j=strlen(str);
 if(i==j)
 {
  fprintf(stderr,"Invalid number %s\n",str);
  exit(1);
 }

 for(res=0;i<j;i++)
 {
  if(str[i]>='0' && str[i]<='9')
   res=res*10+str[i]-'0';
  else
  {
   fprintf(stderr,"Invalid number %s\n",str);
   exit(1);
  }
 }
 return mul*res;
}

int main(int argc,char *argv[])
{
 struct hostent *hosteq;
 struct sockaddr_in host;
 int socketfd;
 int operand1,operand2,operator;
 char buffer[BUFLEN];

// Error check for command line arguments
 if(argc!=5)
 {
  fprintf(stderr,"The format of the input line is as follows :\n");
  fprintf(stderr,"1. Server name (either dns or ip)\n");
  fprintf(stderr,"2. First number\n");
  fprintf(stderr,"3. Operator +,-, x or /\n");
  fprintf(stderr,"4. Second number\n");
  exit(1);
 }
 
// if user enters the name of the server machine obtain its ip
 if((hosteq=gethostbyname(argv[1]))==NULL)
 {
  fprintf(stderr,"If you specified a port number, please remove it!\n");
  fprintf(stderr,"This program uses fixed port number of the address you specified\n");
  exit(1);
 }

 operand1=str_int(argv[2]);
 if(strlen(argv[3])!=1)
 {
  fprintf(stderr,"Invalid Operator\n");
  exit(1);
 }
 else
 {
  switch(argv[3][0])
  {
   case '+' : operator=ADD; break;
   case '-' : operator=SUB; break;
   case 'x' : operator=MUL; break;
   case '/' : operator=DIV;break;
   default  :{
              fprintf(stderr,"Invalid Operator\n");
              exit(1);
             }
  }
 }
 operand2=str_int(argv[4]);
 sprintf(buffer,"%d %d %c",operand1,operand2,operator);

 if((socketfd=socket(AF_INET,SOCK_STREAM,0))==-1)
 {
  perror("socket");
  exit(1);
 }
 
 host.sin_family=AF_INET;
 host.sin_port=htons(PORT);
 host.sin_addr.s_addr=inet_addr(inet_ntoa(*((struct in_addr *)hosteq->h_addr)));
 bzero(host.sin_zero,8);

// connect to the server
 if(connect(socketfd,(struct sockaddr *)&host,sizeof(struct sockaddr))==-1)
 {
  perror("connect");
  exit(1);
 }

// send the formatted user input to the server
 if(send(socketfd,buffer,strlen(buffer)+1,0)==-1)
 {
  perror("send");
  exit(1);
 }

// receive the result returned back from server
 if(recv(socketfd,buffer,BUFLEN,0)==-1)
 {
  perror("receive");
  exit(1);
 }
 
 printf("Resut is : %d\n",str_int(buffer));
 close(socketfd);

 return 0;
}
