#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>

#define FIFONAME "myfifo"

int main(void){
	int n,fd,pid;
	char buffer[1024];
	
	/* Remove any previous fifo. */
	unlink(FIFONAME);
	
	/* Create the FIFO. */
	if (mkfifo(FIFONAME,0666)<0){
		perror("mkfifo");
		exit(1);
	}
	/* Open FIFO for reading. */
	if ((fd=open(FIFONAME,O_RDWR))<0){
		perror("open");
		exit(1);
	}
	while(1){
		if ((pid=fork())==-1){
			printf("Error in fork.\n");
			close(fd);
			exit(1);
		}
		if (pid==0){ 
			int sum,num1,num2;
			if (read(fd,buffer,500)<0){
				perror("Read");
				close(fd);
				exit(1);
			}
			sscanf(buffer,"%d %d",&num1,&num2);
			printf("num1==>%d, num2==>%d, ",num1,num2);
			sum=num1+num2;
			bzero(buffer,100);
			sprintf(buffer,"%d",sum);
			printf("sum==>%d\n",sum);
			if (write(fd,buffer,strlen(buffer))<0){
				printf("Error while sending data.\n");
				exit(1);
			}
			close(fd);
			exit(0);
		}
		else{
			wait(NULL);
		}
	}

}

