/* Ozgur SANLI / 106189-4	*/
/* CENG-332 / HW#4		*/
/* FIFO - Server		*/

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>

#define READ_FIFO	"/tmp/.fifo_r.332"
#define WRITE_FIFO	"/tmp/.fifo_w.332"

void error(char *msg)
{
	perror(msg);
	exit(1);
}

int main(int argc, char **argv)
{
	char buffer[256];
	int fdin, fdout;
	int num1, num2;

	unlink(READ_FIFO);
	unlink(WRITE_FIFO);

	if (mkfifo(READ_FIFO, S_IRWXU) < 0)
		error("mkfifo");

	if (mkfifo(WRITE_FIFO, S_IRWXU) < 0)
		error("mkfifo");

#ifdef DEBUG
	printf("Created fifo files\n");
#endif

	if ((fdin = open(READ_FIFO, O_RDONLY)) < 0)
		error("open");

	if ((fdout = open(WRITE_FIFO, O_WRONLY)) < 0)
		error("open");
#ifdef DEBUG
	printf("opened the fifo files\n");
#endif

	bzero(buffer, 256);
	read(fdin, buffer, 255);
	sscanf(buffer, "%d %d", &num1, &num2);
	fprintf(stdout, "The numbers to be added: %d and %d\n", num1, num2);

#ifdef DEBUG
	printf("Read the numbers from the fifo file\n");
#endif
	bzero(buffer, 256);
	sprintf(buffer, "%d", num1+num2);
	write(fdout, (char *) buffer, strlen(buffer));

#ifdef DEBUG
	printf("Write the result back to the output fifo\n");
#endif
	close(fdin);
	close(fdout);
	return 0;
}
