/* Ozgur SANLI / 106189-4               */
/* CEng-332 / HW#4                      */
/* Internet sockets - Client Program    */

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h> 

#define PORTNO	4444

void error(char *msg)
{
    perror(msg);
    exit(0);
}

int main(int argc, char *argv[])
{
    int sockfd, portno, n;
    int num1, num2;
    struct sockaddr_in serv_addr;
    struct hostent *server;
    char c, buffer[256];

    if (argc < 4) {
       fprintf(stderr,"usage %s hostname num1 num2\n", argv[0]);
       exit(0);
    }

    portno = PORTNO;
    num1 = atoi(argv[2]);	/* Read the numbers to be added */
    num2 = atoi(argv[3]);	/* from command line		*/

    sockfd = socket(AF_INET, SOCK_STREAM, 0);
    if (sockfd < 0) 
        error("ERROR opening socket");

    server = gethostbyname(argv[1]);
    if (server == NULL) {
        fprintf(stderr,"ERROR, no such host\n");
        exit(0);
    }

    bzero((char *) &serv_addr, sizeof(serv_addr));
    serv_addr.sin_family = AF_INET;
    bcopy((char *)server->h_addr, 
         (char *)&serv_addr.sin_addr.s_addr,
         server->h_length);
    serv_addr.sin_port = htons(portno);

    if (connect(sockfd,(struct sockaddr *) &serv_addr,sizeof(serv_addr)) < 0) 
        error("ERROR connecting");

    printf("Press any key to get the sum...");
    fgetc(stdin);

    bzero(buffer,256);
    sprintf(buffer, "%d %d", num1, num2);
    n = write(sockfd,buffer,strlen(buffer));
    if (n < 0) 
         error("ERROR writing to socket");

    bzero(buffer,256);
    n = read(sockfd,buffer,255);
    if (n < 0) 
         error("ERROR reading from socket");
    printf("The result is %s\n",buffer);

    close(sockfd);
    return 0;
}
