/* Ozgur SANLI / 106189-4 		*/
/* CEng-332 / HW#4	  		*/
/* Internet sockets - Server Program 	*/

#include <stdio.h>
#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>

#define PORTNO	4444

void error(char *msg)
{
    perror(msg);
    exit(1);
}

int main(int argc, char *argv[])
{
     int sockfd, newsockfd, portno, clilen;
     char buffer[256];
     struct sockaddr_in serv_addr, cli_addr;
     int n, num1, num2;
     pid_t pid;

     sockfd = socket(AF_INET, SOCK_STREAM, 0);
     if (sockfd < 0) 
        error("ERROR opening socket");

     portno = PORTNO;
     bzero((char *) &serv_addr, sizeof(serv_addr));
     serv_addr.sin_family = AF_INET;
     serv_addr.sin_addr.s_addr = INADDR_ANY;
     serv_addr.sin_port = htons(portno);

     if (bind(sockfd, (struct sockaddr *) &serv_addr,
              sizeof(serv_addr)) < 0) 
	error("ERROR on binding");

     listen(sockfd,5);

     clilen = sizeof(cli_addr);
     newsockfd = accept(sockfd, 
                 (struct sockaddr *) &cli_addr, 
                 &clilen);
     if (newsockfd < 0) 
	error("ERROR on accept");

     /* Create a new child to add two numbers coming from child    */
     /* Then, this new process will send the result back to client */
     if ((pid = fork()) < 0)
	     error("fork");
     if (pid == 0) {
	printf("Hello from the newly forked child!!\n");
	bzero(buffer, 256);
	n = read(newsockfd, buffer, 255);
	if (n < 0) error("ERROR reading from socket");
	printf("Here is the numbers to be added: %s\n",buffer);
	sscanf(buffer, "%d %d", &num1, &num2);

	bzero(buffer, 256);
	sprintf(buffer, "%d", num1+num2);
	n = write(newsockfd, buffer, strlen(buffer));
	if (n < 0) error("ERROR writing to socket");
	close(newsockfd);
	close(sockfd);
	exit(0);
     }

     if (waitpid(pid, NULL, 0) < 0)
	error("waitpid");
     close(newsockfd);
     close(sockfd);
     return 0; 
}
