/* Ozgur SANLI / 106189-4	*/
/* CENG-332 / HW#4		*/
/* UNIX Sockets - Client	*/

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>

#define SOCKET_NAME "/tmp/.socket.e1061894"

void error(char *msg)
{
    perror(msg);
    exit(0);
}

int main(int argc, char *argv[])
{
    int sockfd, servlen, n;
    int num1, num2;
    struct sockaddr_un serv_addr;
    struct hostent *server;
    char c, buffer[256];

    if (argc < 3) {
       fprintf(stderr,"usage %s num1 num2\n", argv[0]);
       exit(0);
    }

    num1 = atoi(argv[1]);	/* Read the numbers to be added */
    num2 = atoi(argv[2]);	/* from command line		*/

    sockfd = socket(AF_UNIX, SOCK_STREAM, 0);
    if (sockfd < 0) 
        error("ERROR opening socket");

    bzero((char *) &serv_addr, sizeof(serv_addr));
    serv_addr.sun_family = AF_UNIX;
    strcpy(serv_addr.sun_path, SOCKET_NAME);
    servlen = strlen(serv_addr.sun_path) + sizeof(serv_addr.sun_family);

    if (connect(sockfd,(struct sockaddr *) &serv_addr, servlen) < 0) 
        error("ERROR connecting");

    printf("Press any key to get the sum...");
    fgetc(stdin);

    bzero(buffer,256);
    sprintf(buffer, "%d %d", num1, num2);
    n = write(sockfd,buffer,strlen(buffer));
    if (n < 0) 
         error("ERROR writing to socket");

    bzero(buffer,256);
    n = read(sockfd,buffer,255);
    if (n < 0) 
         error("ERROR reading from socket");
    printf("The result is %s\n",buffer);

    close(sockfd);
    return 0;
}
