/* Ozgur SANLI / 106189-4 	*/
/* CEng-332 / HW#4	  	*/
/* UNIX Sockets - Server 	*/

#include <stdio.h>
#include <sys/types.h> 
#include <sys/socket.h>
#include <sys/un.h>

#define SOCKET_NAME "/tmp/.socket.e1061894"

void error(char *msg)
{
    perror(msg);
    exit(1);
}

int main(int argc, char *argv[])
{
     int sockfd, newsockfd, servlen, clilen;
     char buffer[256];
     struct sockaddr_un serv_addr, cli_addr;
     int n, num1, num2;
     pid_t pid;

     unlink(SOCKET_NAME);

     sockfd = socket(AF_UNIX, SOCK_STREAM, 0);
     if (sockfd < 0) 
        error("ERROR opening socket");

     bzero((char *) &serv_addr, sizeof(serv_addr));
     serv_addr.sun_family = AF_UNIX;
     strcpy(serv_addr.sun_path, SOCKET_NAME);
     servlen = strlen(serv_addr.sun_path)+sizeof(serv_addr.sun_family);

     if (bind(sockfd, (struct sockaddr *) &serv_addr, servlen) < 0) 
	error("ERROR on binding");

     listen(sockfd,5);

     clilen = sizeof(cli_addr);
     newsockfd = accept(sockfd, 
                 (struct sockaddr *) &cli_addr, 
                 &clilen);
     if (newsockfd < 0) 
	error("ERROR on accept");

     /* Create a new child to add two numbers coming from child    */
     /* Then, this new process will send the result back to client */
     if ((pid = fork()) < 0)
	     error("fork");

     if (pid == 0) {
	printf("Hello from the newly forked child!!\n");
	bzero(buffer, 256);
	n = read(newsockfd, buffer, 255);
	if (n < 0) error("ERROR reading from socket");
	printf("Here is the numbers to be added: %s\n",buffer);
	sscanf(buffer, "%d %d", &num1, &num2);

	bzero(buffer, 256);
	sprintf(buffer, "%d", num1+num2);
	n = write(newsockfd, buffer, strlen(buffer));
	if (n < 0) error("ERROR writing to socket");
	close(newsockfd);
	close(sockfd);
	exit(0);
     }

     if (waitpid(pid, NULL, 0) < 0)
	error("waitpid");
     close(newsockfd);
     close(sockfd);
     return 0; 
}
