#include <sys/socket.h>
#include <sys/types.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>

#define BUF_SIZE		1024
#define FIFO_PATH		"/tmp/.myFifo"

void main(int argc,char **argv) {
	int myFifo,operand1,operand2,sum;
	char dataBuffer[BUF_SIZE];

	if (argc!=3) {
		fprintf(stderr,"\nUsage: client op1 op2\n");
		exit(1);
	}
	/* now open our fifo */
	if ((myFifo=open(FIFO_PATH,O_WRONLY))==-1) {
		perror("open");
		exit(1);
	}
	sscanf(argv[1],"%d",&operand1);
	sscanf(argv[2],"%d",&operand2);
	sprintf(dataBuffer,"%d %d",operand1,operand2);
	if (write(myFifo,dataBuffer,strlen(dataBuffer)+1)==-1) {
		perror("write");
	}
	fprintf(stderr,"client sent operand1:%d operand2:%d...\n",operand1,operand2);
	close(myFifo);
	if ((myFifo=open(FIFO_PATH,O_RDONLY))==-1) {
		perror("open");
		exit(1);
	}
	if (read(myFifo,dataBuffer,sizeof(dataBuffer))==-1) {
		perror("read");
	}
	sscanf(dataBuffer,"%d",&sum);
	fprintf(stderr,"client received sum:%d...\n",sum);
	close(myFifo);
}
