#include <sys/socket.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>

#define BUF_SIZE		1024
#define FIFO_PATH		"/tmp/.myFifo"

void main() {
	int myFifo,operand1,operand2,sum;
	char dataBuffer[BUF_SIZE];

	/* unlink previous file if any */
	unlink(FIFO_PATH);
	if (mkfifo(FIFO_PATH,S_IRWXU)==-1) {
		perror("mkfifo");
		exit(1);
	}
	fprintf(stderr,"created...\n");
	while (1) {
		if ((myFifo=open(FIFO_PATH, O_RDONLY))==-1) {
			perror("open");
			exit(1);
		}
		/* receive the operands from the client */
		if (read(myFifo,dataBuffer,BUF_SIZE)==-1) {
			perror("read");
		}
		close(myFifo);
		sscanf(dataBuffer,"%d %d",&operand1,&operand2);
		fprintf(stderr,"server received operand1:%d operand2:%d...\n",operand1,operand2);
		sum=operand1+operand2;
		sprintf(dataBuffer,"%d",sum);
		if ((myFifo=open(FIFO_PATH, O_WRONLY))==-1) {
			perror("open");
			exit(1);
		}
		/* send the sum to the client */
		if (write(myFifo,dataBuffer,strlen(dataBuffer)+1)==-1) {
			perror("write");
		}
		fprintf(stderr,"server sent sum:%d...\n",sum);
		close(myFifo);
	}
	close(myFifo);
	unlink(FIFO_PATH);
	exit(0);
}
