#include <sys/socket.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>

#define SERVER_PORT		9999
#define BUF_SIZE		1024
#define MAX_HOST_NAME		50
#define DEFAULT_PROTOCOL	0

void main(int argc,char **argv) {
	struct sockaddr_in serverAddr;
	struct hostent *hostEntryPtr;
	int serverFd,operand1,operand2,sum;
	char dataBuffer[BUF_SIZE];

	if (argc!=4) {
		fprintf(stderr,"\nUsage: client serverName op1 op2\n");
		exit(1);
	}
	if ((hostEntryPtr=gethostbyname(argv[1]))==NULL) {
		fprintf(stderr,"%s\n",argv[1]);
		perror("gethostbyname");	
		exit(1);
	}
	memset(&serverAddr,0,sizeof(serverAddr));
	memcpy((char *) &serverAddr.sin_addr,hostEntryPtr->h_addr,hostEntryPtr->h_length);
	serverAddr.sin_family=hostEntryPtr->h_addrtype;
	serverAddr.sin_port=htons(SERVER_PORT);

	/* now open a socket */
	if ((serverFd=socket(AF_INET,SOCK_STREAM,DEFAULT_PROTOCOL))==-1) {
		perror("socket");
		exit(1);
	}
	if (connect(serverFd,(struct sockaddr *)&serverAddr,sizeof(serverAddr))==-1) {
		close(serverFd);
		perror("connect");
		exit(1);
	}
	sscanf(argv[2],"%d",&operand1);
	sscanf(argv[3],"%d",&operand2);
	sprintf(dataBuffer,"%d %d",operand1,operand2);
	fprintf(stderr,"client sent operand1:%d operand2:%d...\n",operand1,operand2);
	if (sendto(serverFd,dataBuffer,strlen(dataBuffer)+1,0,(struct sockaddr *) &serverAddr,sizeof(serverAddr))==-1) {
		perror("sendto");
	}
	if (recv(serverFd,dataBuffer,sizeof(dataBuffer),0)==-1) {
		perror("recv");
	}
	sscanf(dataBuffer,"%d",&sum);
	fprintf(stderr,"client received sum:%d...\n",sum);
}
