#include <sys/socket.h>
#include <sys/types.h>
#include <sys/un.h>
#include <sys/wait.h>
#include <errno.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>

#define BUF_SIZE		1024
#define MAX_HOST_NAME		50
#define DEFAULT_PROTOCOL	0
#define SOCKET_PATH		"/tmp/.mySocket"

void main(int argc,char **argv) {
	struct sockaddr_un serverAddr;
	int serverFd,operand1,operand2,sum;
	char dataBuffer[BUF_SIZE];

	if (argc!=3) {
		fprintf(stderr,"\nUsage: client op1 op2\n");
		exit(1);
	}
	memset(&serverAddr,0,sizeof(serverAddr));
	serverAddr.sun_family=AF_UNIX;
	strcpy(serverAddr.sun_path,SOCKET_PATH);

	/* now open a socket */
	if ((serverFd=socket(AF_UNIX,SOCK_STREAM,DEFAULT_PROTOCOL))==-1) {
		perror("socket");
		exit(1);
	}
	if (connect(serverFd,(struct sockaddr *)&serverAddr,sizeof(serverAddr))==-1) {
		close(serverFd);
		perror("connect");
		exit(1);
	}
	sscanf(argv[1],"%d",&operand1);
	sscanf(argv[2],"%d",&operand2);
	sprintf(dataBuffer,"%d %d",operand1,operand2);
	if (send(serverFd,dataBuffer,strlen(dataBuffer)+1,0)==-1) {
		perror("send");
	}
	fprintf(stderr,"client sent operand1:%d operand2:%d...\n",operand1,operand2);
	if (recv(serverFd,dataBuffer,sizeof(dataBuffer),0)==-1) {
		perror("recv");
	}
	sscanf(dataBuffer,"%d",&sum);
	fprintf(stderr,"client received sum:%d...\n",sum);
}
